//
//  AdDelegate.h
//  PokktSDK
//
//  Created by Subhendu Sekhar Sahu on 09/02/16.
//  Copyright © 2016 Pokkt. All rights reserved.
//

#import <Foundation/Foundation.h>

@class AdResponse;
@class AdConfig;

@protocol AdDelegate <NSObject>

- (void)onPokktInitialised: (BOOL)isReady;

- (void)onAdCachingCompleted: (AdConfig *)adConfig withReward:(float)reward;

- (void)onAdCachingFailed: (AdConfig *)adConfig withErrorMessage:(NSString *)errorMessage;

- (void)onAdCompleted: (AdConfig *)adConfig;

- (void)onAdDisplayed:(AdConfig *)adConfig;

- (void)onAdGratified: (AdConfig *)adConfig withReward:(float)reward;

- (void)onAdSkipped: (AdConfig *)adConfig;

- (void)onAdClosed: (AdConfig *)adConfig;

- (void)onAdAvailabilityStatus: (AdConfig *)adConfig withAvailability:(BOOL)isAdAvailable;

@end
