//
//  PokktManager.h
//  PokktManager
//
//  Created by Pokkt on 5/19/15.
//  Copyright (c) 2015 Pokkt. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "PokktConfig.h"
#import "AdDelegate.h"
#import "InAppPurchaseRequest.h"
#import "NetworkModel.h"
#import <UIKit/UIKit.h>
#import "AdConfig.h"

@interface PokktManager : NSObject

+ (NSString*)getSDKVersion;

+ (void)initPokkt:(PokktConfig *)pokktConfig withDelegate:(id<AdDelegate>)mDelegate;

+ (void)updatePokktConfig: (PokktConfig *)pokktConfig;

+ (void)setDebug:(BOOL)isDebug;

+ (void)startSession;

+ (void)endSession;

+ (void)checkAdAvailability: (AdConfig *)adConfig;

+ (float)getRewardedAdVc: (AdConfig *)adConfig;

+ (void)cacheAd:(AdConfig *)adConfig;

+ (void)showAd:(AdConfig *)adConfig presentingViewController: (UIViewController *)viewController;

+ (void)notifyAppInstall;

+ (void)exportLog:(UIViewController *)viewController;

+ (void)inAppNotificationEvent:(UILocalNotification*)localNotification;

+ (void)callBackgroundTaskCompletionHandler:(void (^)(UIBackgroundFetchResult))completionHandler;

+ (void)trackIAP:(InAppPurchaseRequest*)inAppPurchaseRequest;

+ (int)getCachingTimeoutDuration:(NetworkModel *)networkModel;

+ (void)showToast: (NSString *)message presentingViewController: (UIViewController *)viewController;

@end
