var pe = null;

var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },

    // Bind Event Listeners
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
        document.addEventListener('PokktInitialised', this.onPokktReady, false);
    },

    onDeviceReady: function() {
        console.log('device is ready!');

        pe = window.plugins.pokktExtension;

        pe.setDebug(true);
    },

    onPokktReady: function(isReady) {
        if (isReady) {
            document.getElementById('buttonInitPokkt').value = 'pokkt initialized!';
            document.getElementById('buttonInitPokkt').disabled = true;
            document.getElementById('buttonAdDemoScreen1').disabled = false;
            document.getElementById('buttonAdDemoScreen2').disabled = false;

            // do not enable offerwall for iOS
            if (device.platform != 'iOS') {
                document.getElementById('buttonDemoOfferwall').disabled = false;
            }
        } else {
            document.getElementById('buttonInitPokkt').value = 'Fail to initialize! Try Again!';
            document.getElementById('buttonInitPokkt').disabled = false;
        }
    },

    onClickInitPokkt: function() {
        document.getElementById('buttonInitPokkt').value = 'initializing...';
        document.getElementById('buttonInitPokkt').disabled = true;

        var config = pe.createPokktConfig();
        config.applicationId = 'a2717a45b835b5e9f50284a38d62a74e';
        config.securityKey = 'iJ02lJss0M';
        config.thirdPartyUserId = '123456';
        pe.initPokkt(config)
    },

    onClickAdDemoScreen1: function() {
        window.location = "adDemoScreen1.html";
    },

    onClickAdDemoScreen2: function() {
        window.location = "adDemoScreen2.html";
    },

    onClickDemoOfferwall: function() {
        window.location = "offerwallScreen.html";
    },

    exportLog: function() {
        pe.exportLog();
    }
};